# SiteStat.TCL by VR_Dude (email: vr@aod.net) 
#   - v2.0 release (4/16/98)
#
# Features: 
#   - Upload notify
#   - Stats - Misc stats, user (top ul, top dl), group (top ul, top dl)
#   - Dated dir creation
#   - Dupe checking
#   - Search Upload/Dupe
#   - Nuker
#   - Last Uploads
#   - Dir Stat
#
# To be added:
#   - Add-Ons (stat generate > file)
#
# Greets:
#   ReNeGaUgE, Cybrdeath, BelowZero, |WoLFY|, DuRmUsH, #aod
#   j0ker & GOD-EMPER (beta testers)
#
# Notes: 
#   This tcl was written for and tested on eggdrop v1.1.5+win32/war-ftpd 
#   v1.65. 95% of this code is mine. Some of the ideas for this were taken 
#   from NewFiles.tcl by _GoSSaMeR, and BMScripts by BMBros. Feel free to use
#   the code, but don't forget to give me credit. Read the FAQ..
#

# Use slashes (/) only!
set warlog "c:/war-ftpd/logfile.log";	#where the logfile is located
set warincoming "e:/uploads/0day/";	#0day path (ends with /)
set sitename "My Site";			#site's name
set pubchans "#chan1 #chan2";		#channel(s) to broadcast to
set showuon 0;				#show # of users online (0=off/1=on)
set setmakedir 1;			#creates dated dirs (0=off/1=on)
set showign 1;				#show ign group uploads? (0=off/1=on)
set showlastup 5;			#last uploads to show
set anretry 10;				#try to autonuke x times
set uautonuke 1;			#autonuke dupes (0=off/1=on)
set sonjoin 1;                          #show onjoin in pubchans (0=off/1=on)
set cmdpre "site";                      #command prefix
# End of setup

bind pub - ![set cmdpre]stat sitestat
bind pub - ![set cmdpre]search sitesearch
bind pub - ![set cmdpre]dupe sitedupe
bind pub - ![set cmdpre]last mlastups
bind pub - ![set cmdpre]ver sitever
bind pub - ![set cmdpre]dir sitedir
bind pub - ![set cmdpre]help sitehelp
bind pub o ![set cmdpre]group musergroup
bind pub n ![set cmdpre]nuke nuke
bind dcc o setgroup dusergroup

bind join - * siteonjoin

set userdb "user.ss"
set uploadsdb "uploads.ss"
set fgroups "group.txt"
set flastoct "lastoct.ss"
set miscdb "misc.ss"
set fuon "uon.ss"

set ssver "SiteStat.TCL v2.0 (4/16/98) by VR_Dude"

proc u {} {return };			#underline
proc r {} {return };			#reverse
proc b {} {return };			#bold
proc c {} {return };			#color
proc a {} {return }

if {![info exists lastups]} {set lastups ""}

proc siteonjoin {nick uhost hand chan} {global sonjoin sitename cmdpre pubchans
  if {$sonjoin != "1"} {return 0}
  if {[lsearch [tlow $pubchans] [tlow $chan]] == -1} {return 0}
  putserv "NOTICE $nick :[b]\[[b]$sitename[b]\][b] Type [b]![set cmdpre]help[b] to view the list of commands"
}

proc makedir {} {global warincoming setmakedir
  if {$setmakedir == 0} {return 0}
  set date0 [clock format [expr [unixtime]] -format "%m%d"]
  set date1 [clock format [expr [unixtime] + 86400] -format "%m%d"]
  if {![file isdirectory $warincoming$date0]} {
    file mkdir $warincoming$date0
  }
  if {![file isdirectory $warincoming$date1]} {
    file mkdir $warincoming$date1
  }
}

proc putmem {} {global userdb dsusers ususers
  if {[catch {set of [open $userdb r]}] != 0} {return 0}
  while {![eof $of]} {
    set curline [gets $of]
    if {[string index $curline 0] != "!"} {
      set user [lindex $curline 0]
      set speed [lindex $curline 2]
      set times [lindex $curline 3]
      set size [lindex $curline 4]
      set lspeed [lindex $curline 5]
      set dupesize [lindex $curline 6]
      if {[lindex $curline 1] == 1} {
        set ususers($user) "$speed $times $size $lspeed $dupesize"
      } elseif {[lindex $curline 1] == 0} {
        set dsusers($user) "$speed $times $size $lspeed"
      } 
    }
  }
  close $of
}

proc putfile {} {global userdb dsusers ususers
  if {[catch {set of [open $userdb w]}] != 0} {return 0} {
    foreach user [array names ususers] {
      puts $of "$user 1 $ususers($user)"
    }
    foreach user [array names dsusers] {
      puts $of "$user 0 $dsusers($user)"
    }
  }
  close $of
  unset dsusers ; unset ususers
}

proc updatedb {} {global userdb uploadsdb warlog warincoming dsusers ususers utlast pubchans sitename showign anretry
set stime [unixtime] 
set slastoct [getslastoct]
  if {[file size $warlog] == $slastoct} {return 0}
  if {[file size $warlog] < $slastoct} {set slastoct 0}
  if {$slastoct != 0} {
    putmem
  }
  if {$slastoct == 0} {
    set of [open $uploadsdb w]
    puts $of "\{Started on [ctime [unixtime]]\} \{SiteStat.TCL\}"
    close $of
    putsuon -2
  }
  putslastoct [file size $warlog]
  if {[catch {set of [open $warlog r]}] != 0} {return 0}
  seek $of $slastoct
  while {![eof $of]} {
    set curline [gets $of]
    if {[regexp "Size:" $curline]} {
      if {[regexp "Received file successfully." $curline]} {
        set user [tlow [lindex $curline 6]]
        set speed [lindex $curline [expr [lsearch $curline "Size:"] + 3]]
        set size [lindex $curline [expr [lsearch $curline "Size:"] + 1]]
        chustat $user $speed $size 0
      } elseif {[regexp "File sent successfully."  $curline]} {
        set user [tlow [lindex $curline 6]]
        set speed [lindex $curline [expr [lsearch $curline "Size:"] + 3]]
        set size [lindex $curline [expr [lsearch $curline "Size:"] + 1]]
        chdstat $user $speed $size 
      }
    } elseif {[lrange $curline 11 12] == "logged in"} {
      putsuon [expr [getsuon] + 1]
    } elseif {[lrange $curline 11 12] == "logged out"} {
      if {[lindex $curline 6] != "prelogin"} {
        putsuon [expr [getsuon] - 1]
      }
    } elseif {[lindex $curline 5] == "WAR-FTPD"} {
      putsuon 0
    } elseif {![string compare [lindex $curline 9] "created."]} {
      set updir [string tolower "$warincoming"]
      set of1 [open $uploadsdb a]
      set clean [fixpath $curline]
      set uppath [string range [lindex $clean 8] 0 [expr [string length $updir] -1]]
      if {[tlow $uppath] == $updir} {
        set dpath [string range [lindex $clean 8] [string length $uppath] end]
        set dname [string range $dpath [expr [string last / $dpath]+1] end]
        set duser [tlow [lindex $clean 6]]
        set dupe [dupecheck $dname]
        if {![set dupe]} {puts $of1 "\{$dpath\} \{$duser\} 0"}
        if {[set dupe]} {puts $of1 "\{$dpath\} \{$duser\} 1"}
        lastup $dpath $duser
        if {[string compare [string range $curline 0 19] $utlast] >= 0} {
          putlog "NEWUPLOAD = $dpath - $duser"
          if {($showign == 1 && [getgroup $duser] == "ign") || [getgroup $duser] != "ign"} {
            if {![set dupe]} {
              foreach chan $pubchans {
                putserv "PRIVMSG $chan :\[[b]$sitename[b]\] [b]\([b]$dpath[b]\)[b] [b]-[b] being up'd by [b]\([b]$duser [b]-[b] [getgroup $duser][b]\)[b]"
              }
            } else {
              foreach chan $pubchans {
                putserv "PRIVMSG $chan :\[[b]$sitename[b]\] [r]DUPE[r] [b]\([b]$dpath[b]\)[b] [b]-[b] up'd by [b]\($duser[b] - [getgroup $duser]\)[b]"
              }
              autonuke $dpath $duser $anretry
            }
          }
          set utlast [string range $clean 0 19]
        }
      }
      close $of1
    }
  }
  close $of
  putfile
}

proc dupecheck {upload} {global uploadsdb
  set filerfix [string tolower [fixstr $upload]]
  set of [open $uploadsdb r]
  while {![eof $of]} {
    set curline [gets $of]
    set fx [string tolower [lindex $curline 0]]
    set filesfix [string range $fx [expr [string last / $fx]+1] end]
    if {[string match $filerfix $filesfix] == 1} {
      close $of ; return 1 
    }
  }
  close $of ; return 0
}

proc dupestat {upload} {global uploadsdb
  set filerfix [string tolower [fixstr $upload]]
  set of [open $uploadsdb r]
  while {![eof $of]} {
    set curline [gets $of]
    set fx [string tolower [lindex $curline 0]]
    set filesfix [string tolower $fx]
    if {[string match $filerfix $filesfix] == 1} {
      close $of ; return $curline
    }
  }
  close $of ; return 0
}

proc nuke {nick uhost hand chan args} {global warincoming uploadsdb sitename pubchans
  set args [lindex $args 0]
  if {[llength $args] < 3} {putserv "privmsg $nick :[b]NUKE ERROR[b]: Invalid syntax!" ; return 0}
  set reason [lindex $args 0]
  set mult [lindex $args 1]
  set path [lrange $args 2 end]
  if {$mult <= 1 && $mult >= 1000} {putserv "privmsg $nick :[b]NUKE ERROR[b]: Invalid multiplier!" ; return 0}
  if {![file isdirectory $warincoming$path]} {putserv "privmsg $nick :[b]NUKE ERROR[b]: $path doesn't exist!" ; return 0}
  set size [gs $warincoming$path]
  if {[dupestat $path] == 0} {putserv "privmsg $nick :[b]NUKE ERROR[b]: Directory not found in uploads db!" ; return 0}
  set pos [string last / $path]
  if {$pos == -1} {
    set date ""
    set dir $path
  } else {
    set date [string range $path 0 [expr $pos - 1]]
    set dir [string range $path [expr $pos + 1] end]
  }
  set ren [catch {file rename "$warincoming$path" "$warincoming$date/!!NUKED-$reason-$dir"}] 
  if {$ren != 0} {putserv "privmsg $nick :[b]NUKE ERROR[b]: Couldn't rename the directory!" ; return 0}
  set user [lindex [dupestat $path] 1]
  chustat $user 0 -[expr $size * $mult] 0
  foreach chan $pubchans {
    putserv "PRIVMSG $chan :\[[b]$sitename[b]\] [r]NUKE[r] [b]\([b]$path[b]\)[b] [b]-[b] [b]\[[b]Nuker: [b]$nick[b] Nukee: [b]$user[b] Reason: [b]$reason[b] Credits: [fixsize $size][b]\][b]
  }
}

proc autonuke {path user retry} {global warincoming sitename uautonuke pubchans
putlog "$path $user $retry"
  if {$uautonuke == 0} {return 0}
  if {$retry <= 0} {return 0}
  if {![file isdirectory $warincoming$path]} {return 0}
  set size [gs $warincoming$path]
  set pos [string last / $path]
  if {$pos == -1} {
    set date ""
    set dir $path
  } else {
    set date [string range $path 0 [expr $pos - 1]]
    set dir [string range $path [expr $pos + 1] end]
  }
  set res [catch {file rename $warincoming$path $warincoming$date/!!AUTONUKED-dupe-$dir}]
  if {$res != 0} {timer 1 "autonuke $path $user [expr $retry - 1]" ; return 0}
  chustat $user 0 0 $size
  foreach chan $pubchans {
    putserv "PRIVMSG $chan :\[[b]$sitename[b]\] [r]AUTONUKE[r] [b]\([b]$path[b]\)[b] [b]-[b] [b]\[[b]Nukee: [b]$user[b] Reason: [b]dupe[b] Credits: [fixsize $size][b]\][b]"
  }
}

proc last {txt num} {return "[string range $txt [expr [string length $txt] - $num] end]"}

proc list {dir} {
set ld "" ; set sd ""
  foreach file "[glob -nocomplain $dir/*] [glob -nocomplain $dir/.*]" {
    if {[last $file 2] == "/." || [last $file 3] == "/.."} {continue}
    if {[file isdirectory $file]} {
      lappend ld $file
    } else {
      lappend sd $file
    }
  }
return "{$ld} {$sd}"
}

proc gs {dirs} {
  set sum 0
  while {[lindex $dirs 0] != ""} {
    set ldirs $dirs ; unset dirs
    foreach dir $ldirs {
      set ret [list $dir]
      append dirs "[lindex $ret 0] "
      append files "[lindex $ret 1] "
    }
  }
  foreach file $files {
    if {![file isdirectory $file]} {
      set sum [expr $sum + [file size $file] + 0.0]
    }
  }
return $sum
}

proc sitesearch {nick uhost hand chan args} {global uploadsdb sitename
  if {[catch {set of [open $uploadsdb r]}] != 0} {return 0}
  set args [lindex $args 0]
  set rep 0 ; set repmax 0 ; set ttl 0 ; set det 0 ; set resp 10
  putserv "PRIVMSG $nick :\[[b]$sitename[b]\] [b]Scanning for matches...[b]"
  set filerfix [string tolower [fixstr1 $args]]
  while {![eof $of]} {
    set curline [gets $of]
    if {$curline == ""} {continue}
    if {[lindex $curline 2] == 1} {continue}
    incr ttl
    set filesfix [string tolower $curline]
    if {[string match $filerfix $filesfix] == 1} {
      if {$rep < $resp} {
        putserv "PRIVMSG $nick :[b]\([b][lindex $curline 0][b]\)[b] - [b]\([b][lindex $curline 1] [b]-[b] [getgroup [lindex $curline 1]][b]\)[b]"
        incr rep
      }
      incr repmax
    }
  }
  putserv "PRIVMSG $nick :Listed [b]$rep[b] of [b]$repmax[b] matches of [b]$ttl[b] entries"
  close $of
}

proc sitedupe {nick uhost hand chan args} {global uploadsdb sitename
  if {[catch {set of [open $uploadsdb r]}] != 0} {return 0}
  set args [lindex $args 0]
  set rep 0 ; set repmax 0 ; set ttl 0 ; set det 0 ; set resp 10
  putserv "PRIVMSG $nick :\[[b]$sitename[b]\] [b]Scanning for DUPES...[b]"
  set filerfix [string tolower [fixstr1 $args]]
  while {![eof $of]} {
    set curline [gets $of]
    if {$curline == ""} {continue}
    if {[lindex $curline 2] != 1} {continue}
    incr ttl
    set filesfix [string tolower $curline]
    if {[string match $filerfix $filesfix] == 1} {
      if {$rep < $resp} {
        putserv "PRIVMSG $nick :[b]\([b][lindex $curline 0][b]\)[b] - [b]\([b][lindex $curline 1] [b]-[b] [getgroup [lindex $curline 1]][b]\)[b]"
        incr rep
      }
      incr repmax
    }
  }
  putserv "PRIVMSG $nick :Listed [b]$rep[b] of [b]$repmax[b] matches of [b]$ttl[b] entries"
  close $of
}

proc mlastups {nick uhost hand chan args} {global sitename lastups
  putserv "privmsg $nick :\[[b]$sitename[b]\] [b]Last [llength $lastups] Uploads[b]"
  for {set x 0} {$x<[llength $lastups]} {incr x} {
    if {$x < 10} {set num 0$x} else {set num $x}
    set lastup [lindex $lastups $x]
    putserv "privmsg $nick :\[[b]$num[b]\] [fixlen [lindex $lastup 3] 12] \[[lindex $lastup 0]\] [b]\([b][lindex $lastup 1] [b]-[b] [lindex $lastup 2][b]\)[b]"
  }
}

proc sitever {nick uhost hand chan args} {global ssver sitename
  putserv "privmsg $nick :[b]$sitename is currently using $ssver[b]"
}

proc sitedir {nick uhost hand chan args} {global warincoming sitename
  set dir [lindex $args 0]
  set tf 0 ; set zf 0 ; set tfl "" ; set zfl ""
  if {![file isdirectory $warincoming$dir]} {putserv "privmsg $nick :[b]DIR ERROR[b]: $dir doesn't exist!";return 0}
  if {[regexp {[.][.]/} $dir]} {putserv "privmsg $nick :[b]DIR ERROR[b]: Illegal directory!" ; return 0}
  if {[lindex $dir 0] == "/"} {putserv "privmsg $nick :[b]DIR ERROR[b]: Illegal directory!" ; return 0}
  catch {set zfl [glob $warincoming$dir/*.zip]} 
  catch {set tfl [glob $warincoming$dir/*]}
  foreach file $tfl {if {[file isfile $file]} {incr tf}}
  foreach file $zfl {if {[file isfile $file]} {incr zf}}
  set ts [fixsize [gs $warincoming$dir/]]
  putserv "privmsg $nick :\[[b]$sitename[b]\] [b]Dir Stats on $dir"
  putserv "privmsg $nick :Zip Files:    [b]$zf[b]"
  putserv "privmsg $nick :Total Files:  [b]$tf[b]"
  putserv "privmsg $nick :Total Size:   $ts"
}

proc fixstr {str} {
  set clean ""
  for {set i 0} {$i < [string length $str]} {incr i} {
    set char [string index $str $i]
    if {$char == " " | $char == "." | $char == "_" || $char == "-"} {
      append clean "\?"
    } else { append clean $char }
  }
  return $clean
}

proc fixstr1 {str} {
  set clean ""
  for {set i 0} {$i < [string length $str]} {incr i} {
    set char [string index $str $i]
    if {$char == " " | $char == "." | $char == "_" || $char == "-"} {
      append clean "*"
    } else { append clean $char }
  }
  set clean "\*$clean\*"
  return $clean
}

proc fixpath {path} {
  set clean ""
  for {set i 0} {$i < [string length $path]} {incr i} {
    set char [string index $path $i]
    if {$char == "\\"} {
      append clean "/"
    } else { append clean $char }
  }
  return $clean
}

proc chustat {user adduspeed addusize adupesize} {global ususers
  set addusize [expr $addusize + 0.0]
  if {![info exist ususers($user)]} {
    set ususers($user) "0 0 0 0 0"
  }
  set uspeed [lindex $ususers($user) 0]
  set utimes [lindex $ususers($user) 1] 
  set usize [lindex $ususers($user) 2]
  set setlspeed [lindex $ususers($user) 3]
  set dupesize [lindex $ususers($user) 4]
  if {$adduspeed != 0} {
    set setlspeed [round $adduspeed 2]
    set uttlspeed [expr [adds $uspeed $utimes] + $adduspeed]
    incr utimes
    set uspeed [round [expr $uttlspeed / $utimes] 2]
  }
  if {$addusize != 0} {
    set usize [expr $usize + $addusize]
  }
  if {$adupesize != 0} {
    set dupesize [expr $dupesize + $adupesize]
  }
  set ususers($user) "$uspeed $utimes $usize $setlspeed $dupesize"
}

proc chdstat {user adddspeed adddsize} {global dsusers
  set adddsize [expr $adddsize + 0.0]
  if {![info exist dsusers($user)]} {
    set dsusers($user) "0 0 0 0"
  }
  set dspeed [lindex $dsusers($user) 0]
  set dtimes [lindex $dsusers($user) 1] 
  set dsize [lindex $dsusers($user) 2]
  set setlspeed [lindex $dsusers($user) 3]
  if {$adddspeed != 0} {
    set setlspeed [round $adddspeed 2]
    set dttlspeed [expr [adds $dspeed $dtimes] + $adddspeed]
    incr dtimes
    set dspeed [round [expr $dttlspeed / $dtimes] 2]
  }
  if {$adddsize != 0} {
    set dsize [expr $dsize + $adddsize]
  }
  set dsusers($user) "$dspeed $dtimes $dsize $setlspeed"
}

proc getslastoct {} {global flastoct
  if {![file exists $flastoct]} {putslastoct 0}
  if {[catch {set of [open $flastoct r]}] != 0} {putslastoct 0}
  set oct [gets $of]
  close $of
  if {$oct == ""} {putslastoct 0;set oct 0}
  return $oct
}

proc putslastoct {oct} {global flastoct
  if {[catch {set of [open $flastoct w]}] != 0} {return 0}
  puts $of $oct
  close $of
}

proc lastup {up user} {global lastups showlastup
  set to [expr $showlastup - 2]
  set lastup "\{\{$up\} $user \{[getgroup $user]\} \{[clock format [expr [unixtime]] -format "%m%d%y %H:%M"]\}\}"
  set lastups "$lastup [lrange $lastups 0 $to]"
}

proc getsuon {} {global fuon
  if {![file exists $fuon]} {putsuon -2}
  if {[catch {set of [open $fuon r]}] != 0} {putsuon -2}
  set uon [gets $of]
  close $of
  if {$uon == ""} {putsuon -2;set uon -2}
  return $uon
}

proc getdate {} {miscdb}

proc putsuon {uon} {global fuon
  if {$uon != -2} {
    if {[getsuon] == "-2" && $uon != "0"} {return 0}
  }
  if {[catch {set of [open $fuon w]}] != 0} {return 0}
  puts $of $uon
  close $of
}

proc dusergroup {hand idx args} {
  set args [lindex $args 0]
  set user [tlow [lindex $args 0]]
  set group [tlow [lrange $args 1 end]]
  if {[llength $args] > 1} {
    putgroup $user $group
    putidx $idx "[b]$user[b]'s group has been changed to [b]$group[b]"
  } elseif {[llength $args] == 1} {
    set group [getgroup $user]
    putidx $idx "[b]$user[b]'s current group is [b]$group[b]"
  }
}

proc musergroup {nick uhost hand chan args} {
  set args [lindex $args 0]
  set user [tlow [lindex $args 0]]
  set group [tlow [lrange $args 1 end]]
  if {[llength $args] > 1} {
    putgroup $user $group
    putserv "PRIVMSG $nick :[b]$user[b]'s group has been changed to [b]$group[b]" 
  } elseif {[llength $args] == 1} {
    set group [getgroup $user]
    putserv "PRIVMSG $nick :[b]$user[b]'s current group is [b]$group[b]"
  }
}

proc getgroups {} {global fgroups
  if {![file exists $fgroups]} {putgroups "{default \{none\}}"}
  if {[catch {set of [open $fgroups r]}] != 0} {return 0}
  while {![eof $of]} {
    set curline [gets $of]
    if {$curline != ""} {
      lappend groups $curline
    } 
  }
  close $of
  if {![info exists groups]} {putgroups "{default \{none\}}" ; return [getgroups]}
  return $groups
}

proc putgroups {groups} {global fgroups
  if {[catch {set of [open $fgroups w]}] != 0} {return 0}  
  foreach group $groups {
    puts $of $group
  }
  close $of
}

proc getgroup {user} {
  set user [string tolower $user]
  set groups [getgroups]
  if {[lsearch $groups "$user *"] != -1} {
    set group [lindex $groups [lsearch $groups "$user *"]]
    return [lindex $group 1]
  } else {
    set group [lindex $groups [lsearch $groups "default *"]]
    return [lindex $group 1]
  }
}

proc putgroup {user group} {
  set user [string tolower $user]
  set groups [getgroups]
  if {[getgroup $user] != [getgroup default] || $user == "default"} {
    set groupi [lsearch $groups "$user *"]
    set groups [lreplace $groups $groupi $groupi "$user \{$group\}"]  
  } else {
    lappend groups "$user \{$group\}"
  }
  putgroups $groups
}

proc round {num dec} {
  if {[string first . $num] != -1} {
    set num [string range $num 0 [expr [string first . $num] + $dec]]
    set num [fixlenc $num [expr [string first . $num] + $dec + 1] 0]
    return $num
  } else {
    append num .
    set num [fixlenc $num [expr [string first . $num] + $dec + 1] 0]
    return $num
  }
}

proc adds {num times} {
  set ttl 0
  for {set x 0} {$x < $times} {incr x} {
    set ttl [expr $ttl + $num]
  }
  return $ttl
}

proc sitehelp {nick uhost hand chan args} {
  sitestat $nick $uhost $hand $chan help
}

proc sitestat {nick uhost hand chan args} {global userdb utop dtop usgroup dsgroup gutop gdtop showuon sitename cmdpre
set usum 0;set dsum 0;set utime 0;set dtime 0;set utop "";set dtop "";set aspeed 0;set atimes 0;set topspeed "0 noone";set gdtop "";set gutop ""
  if {[catch {set of [open $userdb r]}] != 0} {return 0} {
    while {![eof $of]} {
      set curline [gets $of]
      if {$curline == ""} {continue}
      set user [lindex $curline 0]
      set speed [lindex $curline 2]
      set times [lindex $curline 3]
      set size [expr [lindex $curline 4] + 0.0]
      set lspeed [lindex $curline 5]
      set dupesize [lindex $curline 6]
      if {[getgroup $user] == "ign"} {continue}
      if {[lindex $topspeed 0] < $speed} {set topspeed "$speed $user"}
      if {[lindex $curline 1] == 1} {
        foreach group [split [getgroup $user] /] {
          chgustat $group $speed $size
        }
        set usum "[expr $size + $usum]"
        makeutop $user $size $speed $lspeed
      } elseif {[lindex $curline 1] == 0} {
        foreach group [split [getgroup $user] /] {
          chgdstat $group $speed $size 
        }
        set dsum [expr $size + $dsum]
        makedtop $user $size $speed $lspeed
      }
      if {$speed != ""} {
        set aspeed [expr $aspeed + [adds $speed $times]]
        set atimes [expr $atimes + $times]
      }
    }
  }
  close $of
  foreach ca [array names usgroup] {
    set group $ca
    set size [lindex $usgroup($group) 2]
    set speed [lindex $usgroup($group) 0]
    makegutop $group $size $speed
  }
  foreach ca [array names dsgroup] {
    set group $ca
    set size [lindex $dsgroup($group) 2]
    set speed [lindex $dsgroup($group) 0]
    makegdtop $group $size $speed
  }
set args [lindex $args 0]
  if {$args == ""} {
    foreach auser $utop {
      set auser [lindex $auser 0]
      lappend ausers $auser
    }
    foreach auser $dtop {
      set auser [lindex $auser 0]
      if {[lsearch $ausers $auser] == -1} {lappend ausers $auser}
    }
    foreach agroup $gutop {
      set agroup [lindex $agroup 0]
      lappend agroups $agroup
    }
    foreach agroup $gdtop {
      set agroup [lindex $agroup 0]
      if {[lsearch $agroups $agroup] == -1} {lappend agroups $agroup}
    }
    putserv "PRIVMSG $nick :[b]SiteStat For $sitename[b]"
    set usumf "[round [lindex [fixsize $usum] 0] 2] [lindex [fixsize $usum] 1]"
    set dsumf "[round [lindex [fixsize $dsum] 0] 2] [lindex [fixsize $dsum] 1]"
    putserv "PRIVMSG $nick :Total Uploads:     [fixsize $usum]"
    putserv "PRIVMSG $nick :Total Downloads:   [fixsize $dsum]"
    putserv "PRIVMSG $nick :Active Users:      [b][llength $ausers][b]"
    putserv "PRIVMSG $nick :Active Groups:     [b][llength $agroups][b]"
if {$showuon} {
    if {[getsuon] == -2} {set uon Unkown} else {set uon [getsuon]}
    putserv "PRIVMSG $nick :Users On-Line:     [b]$uon[b]"
}
    putserv "PRIVMSG $nick :Average Speed:     [b][round [expr $aspeed / $atimes] 2][b]KB/s"
    putserv "PRIVMSG $nick :Top Average Speed: [b][lindex $topspeed 0][b]KB/s set by [b][lindex $topspeed 1][b]"
  } elseif {[lindex $args 0] == "utop"} {
    if {[lindex $args 1] > 0 && [lindex $args 1] <= 100} {
    set ulist [lindex $args 1]} else {set ulist 10}
    set unum 0
    putserv "PRIVMSG $nick :\([b]$sitename[b]\) [b]Top Uploaders[b]"
    foreach cinfo $utop {
      incr unum
      if {$unum <= $ulist} {
        if {$unum < 10} {set cnum 0$unum} else {set cnum $unum}
        putserv "PRIVMSG $nick :\[[b]$cnum[b]\] [fixlenf [lindex $cinfo 0] 10] [fixlenf [fixsize [lindex $cinfo 1]] 10]  [fixlenf \([b][lindex $cinfo 2] 8][b]KB/s\) [b][getgroup [lindex $cinfo 0]][b]"
      }
    }
  } elseif {[lindex $args 0] == "dtop"} {
    if {[lindex $args 1] > 0 && [lindex $args 1] <= 50} {
    set dlist [lindex $args 1]} else {set dlist 10}
    set dnum 0
    putserv "PRIVMSG $nick :\([b]$sitename[b]\) [b]Top Downloaders[b]"
    foreach cinfo $dtop {
      incr dnum
      if {$dnum <= $dlist} {
        if {$dnum < 10} {set cnum 0$dnum} else {set cnum $dnum}
        putserv "PRIVMSG $nick :\[[b]$cnum[b]\] [fixlenf [lindex $cinfo 0] 10] [fixlenf [fixsize [lindex $cinfo 1]] 10]  [fixlenf \([b][lindex $cinfo 2] 8][b]KB/s\) [b][getgroup [lindex $cinfo 0]][b]"
      }
    }
  } elseif {[lindex $args 0] == "user"} {
    if {[lindex $args 1] == ""} {putserv "PRIVMSG $nick :What user?"}
    set user [lindex $args 1]
    set uuser [lsearch [tlow $utop] [tlow "$user *"]] 
    set duser [lsearch [tlow $dtop] [tlow "$user *"]]
    if {$uuser != -1 || $duser != -1} {
      putserv "PRIVMSG $nick :\([b]$sitename[b]\) User Stats on [b]$user[b] - [b][getgroup $user][b]"
      set uspeed [lindex [lindex $utop $uuser] 2]
      set dspeed [lindex [lindex $dtop $duser] 2]
      set luspeed [lindex [lindex $utop $uuser] 3]
      set ldspeed [lindex [lindex $dtop $duser] 3]
      if {$uspeed == ""} {set uspeed 0 ; set luspeed 0}
      if {$dspeed == ""} {set dspeed 0 ; set ldspeed 0}
      if {$uuser == -1} {set usize 0
      } else {set usize [lindex [lindex $utop $uuser] 1]}
      if {$duser == -1} {set dsize 0
      } else {set dsize [lindex [lindex $dtop $duser] 1]}
      if {!$usize} {set unum [expr [llength $utop] + 1]
      } else {set unum [expr $uuser + 1]}
      if {!$dsize} {set dnum [expr [llength $utop] + 1]
      } else {set dnum [expr $duser + 1]}
      if {$unum < 10} {set ucnum 0$unum} else {set ucnum $unum}
      if {$dnum < 10} {set dcnum 0$dnum} else {set dcnum $dnum}
      putserv "PRIVMSG $nick :Uploads:   \[[b]$ucnum[b]\] [fixlenf [fixsize $usize] 9] [b][fixlenf $uspeed 6][b]KB/s"
      putserv "PRIVMSG $nick :Downloads: \[[b]$dcnum[b]\] [fixlenf [fixsize $dsize] 9] [b][fixlenf $dspeed 6][b]KB/s"
      putserv "PRIVMSG $nick :Last Upload Speed:   [b][fixlenf $luspeed 6][b]KB/s"
      putserv "PRIVMSG $nick :Last Download Speed: [b][fixlenf $ldspeed 6][b]KB/s"
    } else {
      putserv "PRIVMSG $nick :User not found."
    }
  } elseif {[lindex $args 0] == "group"} {
    if {[lindex $args 1] == "utop"} {
      if {[lindex $args 2] >= 1 && [lindex $args 2] <= 50} {
      set ulist [lindex $args 2]} else {set ulist 10}
      set unum 0
      putserv "PRIVMSG $nick :\([b]$sitename[b]\) [b]Top Group Uploaders[b]"
      foreach cinfo $gutop {
        incr unum
        if {$unum <= $ulist} {
        if {$unum < 10} {set cnum 0$unum} else {set cnum $unum}
        putserv "PRIVMSG $nick :\[[b]$cnum[b]\] [fixlenf [fixsize [lindex $cinfo 1]] 10]  [fixlenf \([b][lindex $cinfo 2] 8][b]KB/s\)  [b][lindex $cinfo 0][b]"
        }
      }
    } elseif {[lindex $args 1] == "dtop"} {
      if {[lindex $args 2] >= 1 && [lindex $args 2] <= 50} {
      set dlist [lindex $args 2]} else {set dlist 10}
      set dnum 0
      putserv "PRIVMSG $nick :\([b]$sitename[b]\) [b]Top Group Downloaders[b]"
      foreach cinfo $gdtop {
        incr dnum
        if {$dnum <= $dlist} {
        if {$dnum < 10} {set cnum 0$dnum} else {set cnum $dnum}
        putserv "PRIVMSG $nick :\[[b]$cnum[b]\] [fixlenf [fixsize [lindex $cinfo 1]] 10]  [fixlenf \([b][lindex $cinfo 2] 8][b]KB/s\)  [b][lindex $cinfo 0][b]"
        }
      }
    } else {
      if {[lindex $args 1] == ""} {putserv "PRIVMSG $nick :What group?"}
      set group [lindex $args 1]
      set ugroup [lsearch [tlow $gutop] [tlow "\{$group\} *"]] 
      set dgroup [lsearch [tlow $gdtop] [tlow "\{$group\} *"]]
      if {$ugroup != -1 || $dgroup != -1} {
        putserv "PRIVMSG $nick :\([b]$sitename[b]\) Group Stats on [b]$group[b]"
        set uspeed [lindex [lindex $gutop $ugroup] 2]
        set dspeed [lindex [lindex $gdtop $dgroup] 2] 
        if {$ugroup == -1} {set usize 0
        } else {set usize [lindex [lindex $gutop $ugroup] 1]}
        if {$dgroup == -1} {set dsize 0
        } else {set dsize [lindex [lindex $gdtop $dgroup] 1]}
        if {!$usize} {set unum [expr [llength $gutop] + 1]
        } else {set unum [expr $ugroup + 1]}
        if {!$dsize} {set dnum [expr [llength $gutop] + 1]
        } else {set dnum [expr $dgroup + 1]}
        if {$unum < 10} {set ucnum 0$unum} else {set ucnum $unum}
        if {$dnum < 10} {set dcnum 0$dnum} else {set dcnum $dnum}
        putserv "PRIVMSG $nick :Uploads:   \[[b]$ucnum[b]\] [b][fixlenf [fixsize $usize] 9][b]  [b][fixlenf $uspeed 6][b]KB/s"
        putserv "PRIVMSG $nick :Downloads: \[[b]$dcnum[b]\] [b][fixlenf [fixsize $dsize] 9][b]  [b][fixlenf $dspeed 6][b]KB/s" 
      } else {
        putserv "PRIVMSG $nick :Group not found."
      }
    }
  } else {
    putserv "PRIVMSG $nick :\([b]$sitename[b]\) [b]Public Commands[b]"
    putserv "PRIVMSG $nick :![set cmdpre]stat               = shows sitestat"
    putserv "PRIVMSG $nick :![set cmdpre]stat utop          = top uploaders"
    putserv "PRIVMSG $nick :![set cmdpre]stat dtop          = top downloaders"
    putserv "PRIVMSG $nick :![set cmdpre]stat user <user>   = info for user"
    putserv "PRIVMSG $nick :![set cmdpre]stat group utop    = group top uploaders"
    putserv "PRIVMSG $nick :![set cmdpre]stat group dtop    = group top downloaders"
    putserv "PRIVMSG $nick :![set cmdpre]stat group <group> = info on group"
    putserv "PRIVMSG $nick :![set cmdpre]search <pattern>   = searches upload db"
    putserv "PRIVMSG $nick :![set cmdpre]dupe <pattern>     = searches dupe db"
    putserv "PRIVMSG $nick :![set cmdpre]last               = show last uploads"
    putserv "PRIVMSG $nick :![set cmdpre]dir                = shows info on dir"
    putserv "PRIVMSG $nick :\([b]$sitename[b]\) [b]Operator Commands[b]"
    putserv "PRIVMSG $nick :![set cmdpre]group <user> <group>     = change user's group"
    putserv "PRIVMSG $nick :![set cmdpre]nuke <reas> <mult> <dir> = nuke directory"
  }
unset usgroup ; unset dsgroup
}

proc makeutop {user size speed lspeed} {global utop
  if {$utop == ""} {
    set utop "\{$user $size $speed $lspeed\}"
  } else {
    foreach cinfo $utop {
      if {[lindex $cinfo 1] <= $size} {
        set utop [linsert $utop [lsearch $utop $cinfo] "$user $size $speed $lspeed"]
        break
      }
    }
    if {[lsearch $utop "$user *"] == -1} {lappend utop "$user $size $speed $lspeed"}
  }
}


proc makedtop {user size speed lspeed} {global dtop
  if {$dtop == ""} {
    set dtop "\{$user $size $speed $lspeed\}"
  } else {
    foreach cinfo $dtop {
      if {[lindex $cinfo 1] <= $size} {
        set dtop [linsert $dtop [lsearch $dtop $cinfo] "$user $size $speed $lspeed"]
        break
      }
    }
    if {[lsearch $dtop "$user *"] == -1} {lappend dtop "$user $size $speed $lspeed"}
  }
}

proc chgustat {group adduspeed addusize} {global usgroup
  if {![info exist usgroup($group)]} {
    set usgroup($group) "0 0 0"
  }
  set uspeed [lindex $usgroup($group) 0]
  set utimes [lindex $usgroup($group) 1]
  set usize [lindex $usgroup($group) 2]
  if {$adduspeed != 0} {
    set uttlspeed [expr [adds $uspeed $utimes] + $adduspeed]
    incr utimes
    set uspeed [round [expr $uttlspeed / $utimes] 2]
  }
  if {$addusize != 0} {
    set usize [expr $usize + $addusize]
  }
  set usgroup($group) "$uspeed $utimes $usize"
}

proc chgdstat {group adddspeed adddsize} {global dsgroup
  if {![info exist dsgroup($group)]} {
    set dsgroup($group) "0 0 0"
  }
  set dspeed [lindex $dsgroup($group) 0]
  set dtimes [lindex $dsgroup($group) 1]
  set dsize [lindex $dsgroup($group) 2]
  if {$adddspeed != 0} {
    set dttlspeed [expr [adds $dspeed $dtimes] + $adddspeed]
    incr dtimes
    set dspeed [round [expr $dttlspeed / $dtimes] 2]
  }
  if {$adddsize != 0} {
    set dsize [expr $dsize + $adddsize]
  }
  set dsgroup($group) "$dspeed $dtimes $dsize"
}

proc makegutop {group size speed} {global gutop
  set group "\{$group\}" 
  if {$gutop == ""} {
    set gutop "\{$group $size $speed\}"
  } else {
    foreach cinfo $gutop {
      if {[lindex $cinfo 1] <= $size} {
      set gutop [linsert $gutop [lsearch $gutop $cinfo] "$group $size $speed"]
        break
      }
    }
  if {[lsearch $gutop "$group *"] == -1} {lappend gutop "$group $size $speed"}
  }
}

proc makegdtop {group size speed} {global gdtop
  set group "\{$group\}" 
  if {$gdtop == ""} {
    set gdtop "\{$group $size $speed\}"
  } else {
    foreach cinfo $gdtop {
      if {[lindex $cinfo 1] <= $size} {
      set gdtop [linsert $gdtop [lsearch $gdtop $cinfo] "$group $size $speed"]
        break
      }
    }
  if {[lsearch $gdtop "$group *"] == -1} {lappend gdtop "$group $size $speed"}
  }
}

proc fixsize {size} {
  if {$size >= 1000000000} {
    return "[b][round [expr $size / 1000000000.0] 2][b]GB"
  } elseif {$size >= 1000000} {
    return "[b][round [expr $size / 1000000.0] 2][b]MB"
  } elseif {$size >= 1000} {
    return "[b][round [expr $size / 1000.0] 2][b]KB"
  } else {
    return "[b]$size[b]B"
  } 
}

proc tlow {txt} {return [string tolower $txt]}
proc tup {txt} {return [string toupper $txt]}

proc fixlen {txt len} {
while {[string length $txt] < $len} {append txt " "}
return $txt}

proc fixlenc {txt len char} {
while {[string length $txt] < $len} {append txt $char}
return $txt}

proc fixlenf {txt len} {
while {[string length $txt] < $len} {set txt " $txt"}
return $txt}

proc writestat {} {}

if {![regexp updatedb [timers]]} {
  putlog "SiteStat.TCL v2.0 by VR_Dude Loaded"
  if {![file isfile $warlog]} {return "SiteStat.TCL: $warlog not found!"}
  if {![file isdirectory $warincoming]} {return "SiteStat.TCL: $warincoming not found!"}
  if {[catch {set of [open $userdb a]}] != 0} {return "SiteStat.TCL: can't open $userdb"} ; close $of
  if {[catch {set of [open $uploadsdb a]}] != 0} {return "SiteStat.TCL: can't open $uploadsdb"} ; close $of
  if {[catch {set of [open $fgroups a]}] != 0} {return "SiteStat.TCL: can't open $fgroups"} ; close $of
  if {[catch {set of [open $flastoct a]}] != 0} {return "SiteStat.TCL: can't open $flastoct"} ; close $of ; unset of
  putlog "SiteStat.TCL Checking Paths... OK"
  timer 7 tupdatedb
  set utlast [clock format [clock seconds] -format "\[F %Y %m %d %H:%M\]"]
  updatedb
}

proc tupdatedb {} {
   timer 1 tupdatedb
   updatedb
   writestat
   makedir
   return 0
}
